<script setup lang="ts">
import { ref, watch } from 'vue'

// Definición de props con tipado en TypeScript y asignación a variables locales
const props = withDefaults(defineProps<{
  username?: string
  role?: string
}>(), {
  username: 'Default Username',
  role: 'Default Role',
})

const initials = ref('')
const variant = ref('')

// Funciones para calcular iniciales y variantes basadas en el usuario y rol
const updateInitials = (username: string) => {
  initials.value = username.slice(0, 2).toUpperCase()
  console.log('UserAvatar: this.initials', initials.value)
}

const updateVariant = (role: string) => {
  const roleNormalized = role.trim().toLowerCase()

  const roleVariantMap: Record<string, string> = {
    root: 'error',
    admin: 'primary',
    developer: 'warning',
    user: 'success',
  }

  variant.value = roleVariantMap[roleNormalized] || 'secondary'
  console.log('UserAvatar: this.variant', variant.value)
}

// Observadores reactivos para cambios en las props de username y role
watch(() => props.username, (newVal, oldVal) => {
  console.log('UserAvatar: username changed', newVal, oldVal)
  updateInitials(newVal)
}, { immediate: true })

watch(() => props.role, (newVal, oldVal) => {
  console.log('UserColor: role changed', newVal, oldVal)
  updateVariant(newVal)
}, { immediate: true })

// Llamadas iniciales a las funciones para establecer los valores iniciales
updateInitials(props.username)
updateVariant(props.role)
</script>

<template>
  <VAvatar
    class="cursor-pointer"
    size="40"
    :color="variant"
    variant="tonal"
  >
    {{ initials }}
  </VAvatar>
</template>
